/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ds.trans.example3.service.impl;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import rs.ds.trans.example3.domen.City;
import rs.ds.trans.example3.repository.CityRepository;
import rs.ds.trans.example3.service.CityService;

/**
 *
 * @author user
 */
@Service(value = "cityService")
@Transactional
public class CityServiceImpl implements CityService {
    
    
    @Autowired
    private CityRepository cityRepository;

    public CityServiceImpl() {
        System.out.println("Constructor CityServiceImpl....");
    }
    
    @Override
    @Transactional(readOnly = true)
    public List<City> findAll() {
        return cityRepository.findAll();
    }

    @Override    
    public City findByPtt(Long ptt) {
        return cityRepository.findByPtt(ptt);
    }
        
    @Override
    //u okviru tekuce, ako ne onda otvori novu
    //@Transactional(propagation = Propagation.REQUIRED)    
    
    //uvek nova
    //@Transactional(propagation = Propagation.REQUIRES_NEW)    
    public City saveCity(City city) {
        return cityRepository.save(city);
    }

}
